<?php
class ControllerExtensionPaymentSecureTradingPp {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/securetrading_pp');

		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			request::$post['payment_securetrading_pp_site_reference'] = trim(request::$post['payment_securetrading_pp_site_reference']);

			admin_setting_setting::editSetting('payment_securetrading_pp', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(request::$post['payment_securetrading_pp_site_reference'])) {
			$data['payment_securetrading_pp_site_reference'] = request::$post['payment_securetrading_pp_site_reference'];
		} else {
			$data['payment_securetrading_pp_site_reference'] = config::get('payment_securetrading_pp_site_reference');
		}

		if (isset(request::$post['payment_securetrading_pp_version'])) {
			$data['payment_securetrading_pp_version'] = request::$post['payment_securetrading_pp_version'];
		} else {
			$data['payment_securetrading_pp_version'] = config::get('payment_securetrading_pp_version');
		}

		if (isset(request::$post['payment_securetrading_pp_username'])) {
			$data['payment_securetrading_pp_username'] = request::$post['payment_securetrading_pp_username'];
		} else {
			$data['payment_securetrading_pp_username'] = config::get('payment_securetrading_pp_username');
		}

		if (isset(request::$post['payment_securetrading_pp_password'])) {
			$data['payment_securetrading_pp_password'] = request::$post['payment_securetrading_pp_password'];
		} else {
			$data['payment_securetrading_pp_password'] = config::get('payment_securetrading_pp_password');
		}

		if (isset(request::$post['payment_securetrading_pp_notification_password'])) {
			$data['payment_securetrading_pp_notification_password'] = request::$post['payment_securetrading_pp_notification_password'];
		} else {
			$data['payment_securetrading_pp_notification_password'] = config::get('payment_securetrading_pp_notification_password');
		}

		if (isset(request::$post['payment_securetrading_pp_site_security_password'])) {
			$data['payment_securetrading_pp_site_security_password'] = request::$post['payment_securetrading_pp_site_security_password'];
		} else {
			$data['payment_securetrading_pp_site_security_password'] = config::get('payment_securetrading_pp_site_security_password');
		}

		if (isset(request::$post['payment_securetrading_pp_site_security_status'])) {
			$data['payment_securetrading_pp_site_security_status'] = request::$post['payment_securetrading_pp_site_security_status'];
		} else {
			$data['payment_securetrading_pp_site_security_status'] = config::get('payment_securetrading_pp_site_security_status');
		}

		if (isset(request::$post['payment_securetrading_pp_webservice_username'])) {
			$data['payment_securetrading_pp_webservice_username'] = request::$post['payment_securetrading_pp_webservice_username'];
		} else {
			$data['payment_securetrading_pp_webservice_username'] = config::get('payment_securetrading_pp_webservice_username');
		}

		if (isset(request::$post['payment_securetrading_pp_webservice_password'])) {
			$data['payment_securetrading_pp_webservice_password'] = request::$post['payment_securetrading_pp_webservice_password'];
		} else {
			$data['payment_securetrading_pp_webservice_password'] = config::get('payment_securetrading_pp_webservice_password');
		}

		if (isset(request::$post['payment_securetrading_pp_order_status_id'])) {
			$data['payment_securetrading_pp_order_status_id'] = request::$post['payment_securetrading_pp_order_status_id'];
		} elseif(config::get('payment_securetrading_pp_order_status_id') != '') {
			$data['payment_securetrading_pp_order_status_id'] = config::get('payment_securetrading_pp_order_status_id');
		} else {
			$data['payment_securetrading_pp_order_status_id'] = 1;
		}

		if (isset(request::$post['payment_securetrading_pp_declined_order_status_id'])) {
			$data['payment_securetrading_pp_declined_order_status_id'] = request::$post['payment_securetrading_pp_declined_order_status_id'];
		} elseif(config::get('payment_securetrading_pp_declined_order_status_id') != '') {
			$data['payment_securetrading_pp_declined_order_status_id'] = config::get('payment_securetrading_pp_declined_order_status_id');
		} else {
			$data['payment_securetrading_pp_declined_order_status_id'] = 8;
		}

		if (isset(request::$post['payment_securetrading_pp_refunded_order_status_id'])) {
			$data['payment_securetrading_pp_refunded_order_status_id'] = request::$post['payment_securetrading_pp_refunded_order_status_id'];
		} elseif(config::get('payment_securetrading_pp_refunded_order_status_id') != '') {
			$data['payment_securetrading_pp_refunded_order_status_id'] = config::get('payment_securetrading_pp_refunded_order_status_id');
		} else {
			$data['payment_securetrading_pp_refunded_order_status_id'] = 11;
		}

		if (isset(request::$post['payment_securetrading_pp_authorisation_reversed_order_status_id'])) {
			$data['payment_securetrading_pp_authorisation_reversed_order_status_id'] = request::$post['payment_securetrading_pp_authorisation_reversed_order_status_id'];
		} elseif(config::get('payment_securetrading_pp_authorisation_reversed_order_status_id') != '') {
			$data['payment_securetrading_pp_authorisation_reversed_order_status_id'] = config::get('payment_securetrading_pp_authorisation_reversed_order_status_id');
		} else {
			$data['payment_securetrading_pp_authorisation_reversed_order_status_id'] = 12;
		}

		if (isset(request::$post['payment_securetrading_pp_settle_status'])) {
			$data['payment_securetrading_pp_settle_status'] = request::$post['payment_securetrading_pp_settle_status'];
		} else {
			$data['payment_securetrading_pp_settle_status'] = config::get('payment_securetrading_pp_settle_status');
		}

		if (isset(request::$post['payment_securetrading_pp_settle_due_date'])) {
			$data['payment_securetrading_pp_settle_due_date'] = request::$post['payment_securetrading_pp_settle_due_date'];
		} else {
			$data['payment_securetrading_pp_settle_due_date'] = config::get('payment_securetrading_pp_settle_due_date');
		}

		if (isset(request::$post['payment_securetrading_pp_geo_zone_id'])) {
			$data['payment_securetrading_pp_geo_zone_id'] = request::$post['payment_securetrading_pp_geo_zone_id'];
		} else {
			$data['payment_securetrading_pp_geo_zone_id'] = config::get('payment_securetrading_pp_geo_zone_id');
		}

		if (isset(request::$post['payment_securetrading_pp_status'])) {
			$data['payment_securetrading_pp_status'] = request::$post['payment_securetrading_pp_status'];
		} else {
			$data['payment_securetrading_pp_status'] = config::get('payment_securetrading_pp_status');
		}

		if (isset(request::$post['payment_securetrading_pp_sort_order'])) {
			$data['payment_securetrading_pp_sort_order'] = request::$post['payment_securetrading_pp_sort_order'];
		} else {
			$data['payment_securetrading_pp_sort_order'] = config::get('payment_securetrading_pp_sort_order');
		}

		if (isset(request::$post['payment_securetrading_pp_total'])) {
			$data['payment_securetrading_pp_total'] = request::$post['payment_securetrading_pp_total'];
		} else {
			$data['payment_securetrading_pp_total'] = config::get('payment_securetrading_pp_total');
		}

		if (isset(request::$post['payment_securetrading_pp_parent_css'])) {
			$data['payment_securetrading_pp_parent_css'] = request::$post['payment_securetrading_pp_parent_css'];
		} else {
			$data['payment_securetrading_pp_parent_css'] = config::get('payment_securetrading_pp_parent_css');
		}

		if (isset(request::$post['payment_securetrading_pp_child_css'])) {
			$data['payment_securetrading_pp_child_css'] = request::$post['payment_securetrading_pp_child_css'];
		} else {
			$data['payment_securetrading_pp_child_css'] = config::get('payment_securetrading_pp_child_css');
		}

		if (isset(request::$post['payment_securetrading_pp_cards_accepted'])) {
			$data['payment_securetrading_pp_cards_accepted'] = request::$post['payment_securetrading_pp_cards_accepted'];
		} else {
			$data['payment_securetrading_pp_cards_accepted'] = config::get('payment_securetrading_pp_cards_accepted');

			if ($data['payment_securetrading_pp_cards_accepted'] == null) {
				$data['payment_securetrading_pp_cards_accepted'] = array();
			}
		}

		document::setTitle(language::get('heading_title'));

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['site_reference'])) {
			$data['error_site_reference'] = self::$error['site_reference'];
		} else {
			$data['error_site_reference'] = '';
		}

		if (isset(self::$error['version'])) {
			$data['error_version'] = self::$error['version'];
		} else {
			$data['error_version'] = '';
		}

		if (isset(self::$error['cards_accepted'])) {
			$data['error_cards_accepted'] = self::$error['cards_accepted'];
		} else {
			$data['error_cards_accepted'] = '';
		}

		if (isset(self::$error['notification_password'])) {
			$data['error_notification_password'] = self::$error['notification_password'];
		} else {
			$data['error_notification_password'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/securetrading_pp')
		);

		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();
		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();
		$data['cards'] = array(
			'AMEX' => 'American Express',
			'VISA' => 'Visa',
			'DELTA' => 'Visa Debit',
			'ELECTRON' => 'Visa Electron',
			'PURCHASING' => 'Visa Purchasing',
			'VPAY' => 'V Pay',
			'MASTERCARD' => 'MasterCard',
			'MASTERCARDDEBIT' => 'MasterCard Debit',
			'MAESTRO' => 'Maestro',
			'PAYPAL' => 'PayPal',
		);

		$data['settlement_statuses'] = array(
			'0' => language::get('text_pending_settlement'),
			'1' => language::get('text_pending_settlement_manually_overriden'),
			'2' => language::get('text_pending_suspended'),
			'100' => language::get('text_pending_settled'),
		);

		$data['action'] = url::link('extension/payment/securetrading_pp');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/securetrading_pp', $data));
	}

	public static function install() {
		admin_extension_payment_securetrading_pp::install();
	}

	public static function uninstall() {
		admin_extension_payment_securetrading_pp::uninstall();
	}

	public static function order() {
		if (config::get('payment_securetrading_pp_status')) {

			$securetrading_pp_order = admin_extension_payment_securetrading_pp::getOrder(request::$get['order_id']);

			if (!empty($securetrading_pp_order)) {
				load::language('extension/payment/securetrading_pp');

				$securetrading_pp_order['total_released'] = admin_extension_payment_securetrading_pp::getTotalReleased($securetrading_pp_order['securetrading_pp_order_id']);

				$securetrading_pp_order['total_formatted'] = currency::format($securetrading_pp_order['total'], $securetrading_pp_order['currency_code'], false, false);
				$securetrading_pp_order['total_released_formatted'] = currency::format($securetrading_pp_order['total_released'], $securetrading_pp_order['currency_code'], false, false);

				$data['securetrading_pp_order'] = $securetrading_pp_order;

				$data['auto_settle'] = $securetrading_pp_order['settle_type'];

				$data['order_id'] = (int)request::$get['order_id'];
				

				return load::view('extension/payment/securetrading_pp_order', $data);
			}
		}
	}

	public static function void() {
		load::language('extension/payment/securetrading_pp');
		$json = array();

		if (isset(request::$post['order_id']) && request::$post['order_id'] != '') {

			$securetrading_pp_order = admin_extension_payment_securetrading_pp::getOrder(request::$post['order_id']);

			$void_response = admin_extension_payment_securetrading_pp::void(request::$post['order_id']);

			admin_extension_payment_securetrading_pp::logger('Void result:\r\n' . print_r($void_response, 1));

			if ($void_response !== false) {
				$response_xml = simplexml_load_string($void_response);

				if ($response_xml::$response['type'] == 'ERROR' || (string)$response_xml::$response::$error::$code != '0') {
					$json['msg'] = (string)$response_xml::$response::$error::$message;
					$json['error'] = true;
				} else {

					admin_extension_payment_securetrading_pp::addTransaction($securetrading_pp_order['securetrading_pp_order_id'], 'reversed', 0.00);
					admin_extension_payment_securetrading_pp::updateVoidStatus($securetrading_pp_order['securetrading_pp_order_id'], 1);

					self::$data = array(
						'order_status_id' => config::get('payment_securetrading_pp_authorisation_reversed_order_status_id'),
						'notify' => false,
						'comment' => '',
					);


					admin_sale_order::addOrderHistory(request::$post['order_id'], self::$data);

					$json['msg'] = language::get('text_authorisation_reversed');
					$json['data']['created'] = date("Y-m-d H:i:s");
					$json['error'] = false;
				}
			} else {
				$json['msg'] = language::get('error_connection');
				$json['error'] = true;
			}
		} else {
			$json['error'] = true;
			$json['msg'] = 'Missing data';
		}

		response::setOutput(json_encode($json));
	}

	public static function release() {
		load::language('extension/payment/securetrading_pp');
		$json = array();

		$amount = number_format(request::$post['amount'], 2);

		if (isset(request::$post['order_id']) && request::$post['order_id'] != '' && isset($amount) && $amount > 0) {

			$securetrading_pp_order = admin_extension_payment_securetrading_pp::getOrder(request::$post['order_id']);

			$release_response = admin_extension_payment_securetrading_pp::release(request::$post['order_id'], $amount);

			admin_extension_payment_securetrading_pp::logger('Release result:\r\n' . print_r($release_response, 1));

			if ($release_response !== false) {
				$response_xml = simplexml_load_string($release_response);

				if ($response_xml::$response['type'] == 'ERROR' || (string)$response_xml::$response::$error::$code != '0') {
					$json['error'] = true;
					$json['msg'] = (string)$response_xml::$response::$error::$message;
				} else {
					admin_extension_payment_securetrading_pp::addTransaction($securetrading_pp_order['securetrading_pp_order_id'], 'payment', $amount);

					$total_released = admin_extension_payment_securetrading_pp::getTotalReleased($securetrading_pp_order['securetrading_pp_order_id']);

					if ($total_released >= $securetrading_pp_order['total'] || $securetrading_pp_order['settle_type'] == 100) {
						admin_extension_payment_securetrading_pp::updateReleaseStatus($securetrading_pp_order['securetrading_pp_order_id'], 1);
						$release_status = 1;
						$json['msg'] = language::get('text_release_ok_order');


						$history = array();
						$history['order_status_id'] = config::get('securetrading_pp_order_status_success_settled_id');
						$history['comment'] = '';
						$history['notify'] = '';

						admin_sale_order::addOrderHistory(request::$post['order_id'], $history);
					} else {
						$release_status = 0;
						$json['msg'] = language::get('text_release_ok');
					}

					$json['data'] = array();
					$json['data']['created'] = date("Y-m-d H:i:s");
					$json['data']['amount'] = $amount;
					$json['data']['release_status'] = $release_status;
					$json['data']['total'] = (double)$total_released;
					$json['error'] = false;
				}
			} else {
				$json['error'] = true;
				$json['msg'] = language::get('error_connection');
			}
		} else {
			$json['error'] = true;
			$json['msg'] = language::get('error_data_missing');
		}

		response::setOutput(json_encode($json));
	}

	public static function rebate() {
		load::language('extension/payment/securetrading_pp');
		$json = array();

		if (isset(request::$post['order_id']) && !empty(request::$post['order_id'])) {

			$securetrading_pp_order = admin_extension_payment_securetrading_pp::getOrder(request::$post['order_id']);

			$amount = number_format(request::$post['amount'], 2);

			$rebate_response = admin_extension_payment_securetrading_pp::rebate(request::$post['order_id'], $amount);

			admin_extension_payment_securetrading_pp::logger('Rebate result:\r\n' . print_r($rebate_response, 1));

			if ($rebate_response !== false) {
				$response_xml = simplexml_load_string($rebate_response);

				$error_code = (string)$response_xml::$response::$error::$code;

				if ($error_code == '0') {

					admin_extension_payment_securetrading_pp::addTransaction($securetrading_pp_order['securetrading_pp_order_id'], 'rebate', $amount * -1);

					$total_rebated = admin_extension_payment_securetrading_pp::getTotalRebated($securetrading_pp_order['securetrading_pp_order_id']);
					$total_released = admin_extension_payment_securetrading_pp::getTotalReleased($securetrading_pp_order['securetrading_pp_order_id']);

					if ($total_released <= 0 && $securetrading_pp_order['release_status'] == 1) {
						$json['status'] = 1;
						$json['message'] = language::get('text_refund_issued');

						admin_extension_payment_securetrading_pp::updateRebateStatus($securetrading_pp_order['securetrading_pp_order_id'], 1);
						$rebate_status = 1;
						$json['msg'] = language::get('text_rebate_ok_order');


						$history = array();
						$history['order_status_id'] = config::get('payment_securetrading_pp_refunded_order_status_id');
						$history['comment'] = '';
						$history['notify'] = '';

						admin_sale_order::addOrderHistory(request::$post['order_id'], $history);
					} else {
						$rebate_status = 0;
						$json['msg'] = language::get('text_rebate_ok');
					}

					$json['data'] = array();
					$json['data']['created'] = date("Y-m-d H:i:s");
					$json['data']['amount'] = $amount * -1;
					$json['data']['total_released'] = (double)$total_released;
					$json['data']['total_rebated'] = (double)$total_rebated;
					$json['data']['rebate_status'] = $rebate_status;
					$json['error'] = false;
				} else {
					$json['error'] = true;
					$json['msg'] = (string)$response_xml::$response::$error::$message;
				}
			} else {
				$json['status'] = 0;
				$json['message'] = language::get('error_connection');
			}
		} else {
			$json['error'] = true;
			$json['msg'] = 'Missing data';
		}

		response::setOutput(json_encode($json));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/securetrading_pp')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_securetrading_pp_site_reference']) {
			self::$error['site_reference'] = language::get('error_site_reference');
		}

		if (!request::$post['payment_securetrading_pp_version']) {
			self::$error['version'] = language::get('error_version');
		}

		if (empty(request::$post['payment_securetrading_pp_cards_accepted'])) {
			self::$error['cards_accepted'] = language::get('error_cards_accepted');
		}

		if (!request::$post['payment_securetrading_pp_notification_password']) {
			self::$error['notification_password'] = language::get('error_notification_password');
		}

		return !self::$error;
	}
}