<?php
class ControllerMailForgotten {
	public static function index(&$route, &$args, &$output) {			            
		load::language('mail/forgotten');
		
		$data['text_greeting'] = sprintf(language::get('text_greeting'), html_entity_decode(config('name'), ENT_QUOTES, 'UTF-8'));
		
		$data['reset'] = str_replace('&amp;', '&', url::link('common/reset', 'code=' . $args[1]));
		$data['ip'] = request::$server['REMOTE_ADDR'];
		
		$mail = new Mail(config('mail_engine'));
		$mail::$parameter = config('mail_parameter');
		$mail::$smtp_hostname = config('mail_smtp_hostname');
		$mail::$smtp_username = config('mail_smtp_username');
		$mail::$smtp_password = html_entity_decode(config('mail_smtp_password'), ENT_QUOTES, 'UTF-8');
		$mail::$smtp_port = config('mail_smtp_port');
		$mail::$smtp_timeout = config('mail_smtp_timeout');

		$mail::setTo($args[0]);
		$mail::setFrom(config('email'));
		$mail::setSender(html_entity_decode(config('name'), ENT_QUOTES, 'UTF-8'));
		$mail::setSubject(html_entity_decode(sprintf(language::get('text_subject'), html_entity_decode(config('name'), ENT_QUOTES, 'UTF-8')), ENT_QUOTES, 'UTF-8'));
		$mail::setText(load::view('mail/forgotten', $data));
		$mail::send();
	}
}
