<?php
class ControllerStartupStartup {
	public static function index() {
		// Settings
		$query = db::query("SELECT * FROM setting WHERE store_id = '0'");
		
		foreach ($query->rows as $setting) {
			if (!$setting['serialized']) {
				config::set($setting['key'], $setting['value']);
			} else {
				config::set($setting['key'], json_decode($setting['value'], true));
			}
		}

		// Set time zone
		if (config('timezone')) {
			date_default_timezone_set(config('timezone'));

			// Sync PHP and DB time zones.
			db::query("SET time_zone = " . esc(date('P')));
		}

		// Theme
		config::set('template_cache', config::get('developer_theme'));
				
		// Language
		$query = db::query("SELECT * FROM `language` WHERE code = " . esc(config('admin_language')));
		
		if ($query->num_rows) {
			config::set('config_language_id', $query->row['language_id']);
		}
		
		// Language
		language::load(config('admin_language'));

		// Customer

		// Currency
	
		// Tax
		
		if (config('tax_default') == 'shipping') {
			tax::setShippingAddress(config('country_id'), config('zone_id'));
		}

		if (config('tax_default') == 'payment') {
			tax::setPaymentAddress(config('country_id'), config('zone_id'));
		}

		tax::setStoreAddress(config('country_id'), config('zone_id'));

		// Weight
		
		// Length
		
		// Cart
		
		// Encryption
	}
}