<?php
class admin_extension_dashboard_map {
	public static function getTotalOrdersByCountry() {
		$implode = array();
		
		if (is_array(config('complete_status'))) {
			foreach (config('complete_status') as $order_status_id) {
				$implode[] = (int)$order_status_id;
			}
		}
		
		if ($implode) {
			$query = db::query("SELECT COUNT(*) AS total, SUM(o.total) AS amount, c.iso_code_2 FROM `order` o LEFT JOIN `country` c ON (o.payment_country_id = c.country_id) WHERE o.order_status_id IN(" . implode(',', $implode) . ") GROUP BY o.payment_country_id");

			return $query->rows;
		} else {
			return array();
		}
	}
}
