<?php
class admin_extension_dashboard_online {
	public static function getTotalOnline($data = array()) {
		$sql = "SELECT COUNT(*) AS total FROM `customer_online` co LEFT JOIN customer c ON (co.customer_id = c.customer_id)";

		$implode = array();

		if (!empty($data['filter_ip'])) {
			$implode[] = "co.ip LIKE " . esc($data['filter_ip']);
		}

		if (!empty($data['filter_customer'])) {
			$implode[] = "co.customer_id > 0 AND CONCAT(c.firstname, ' ', c.lastname) LIKE " . esc($data['filter_customer']);
		}

		if ($implode) {
			$sql .= " WHERE " . implode(" AND ", $implode);
		}

		$query = db::query($sql);

		return $query->row['total'];
	}
}