<?php
class admin_extension_payment_paypal {
		
	public static function configureSmartButton() {
		
		$query = db::query("SELECT * FROM extension WHERE `code` = 'paypal_smart_button'");
        		
        if (empty($query->row)) {
            db::query("INSERT INTO extension SET `type` = 'module', `code` = 'paypal_smart_button'");

            $user_group_id = user::getGroupId();
       									
			admin_user_user_group::addPermission($user_group_id, 'access', 'extension/module/paypal_smart_button');
			admin_user_user_group::addPermission($user_group_id, 'modify', 'extension/module/paypal_smart_button');
			
			load::controller('extension/module/paypal_smart_button/install');
        }
	}
	
	public static function log($data, $title = null) {
		if (config::get('payment_paypal_debug')) {
			$log = new Log('paypal.log');
			$log::write('PayPal debug (' . $title . '): ' . json_encode($data));
		}
	}
}
