<?php
class admin_setting_modification {
	public static function addModification($data) {
		db::query("INSERT INTO `modification` SET `extension_install_id` = " . (int)$data['extension_install_id'] . ", `name` = " . esc($data['name']) . ", `code` = " . esc($data['code']) . ", `author` = " . esc($data['author']) . ", `version` = " . esc($data['version']) . ", `link` = " . esc($data['link']) . ", `xml` = " . esc($data['xml']) . ", `status` = " . (int)$data['status'] . ", `date_added` = NOW()");
	}

	public static function deleteModification($modification_id) {
		db::query("DELETE FROM `modification` WHERE `modification_id` = " . (int)$modification_id);
	}

	public static function deleteModificationsByExtensionInstallId($extension_install_id) {
		db::query("DELETE FROM `modification` WHERE `extension_install_id` = " . (int)$extension_install_id);
	}
	
	public static function enableModification($modification_id) {
		db::query("UPDATE `modification` SET `status` = '1' WHERE `modification_id` = " . (int)$modification_id);
	}

	public static function disableModification($modification_id) {
		db::query("UPDATE `modification` SET `status` = '0' WHERE `modification_id` = " . (int)$modification_id);
	}

	public static function getModification($modification_id) {
		$query = db::query("SELECT * FROM `modification` WHERE `modification_id` = " . (int)$modification_id);

		return $query->row;
	}

	public static function getModifications($data = array()) {
		$sql = "SELECT * FROM `modification`";

		$sort_data = array(
			'name',
			'author',
			'version',
			'status',
			'date_added'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY name";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getTotalModifications() {
		$query = db::query("SELECT COUNT(*) AS total FROM `modification`");

		return $query->row['total'];
	}
	
	public static function getModificationByCode($code) {
		$query = db::query("SELECT * FROM `modification` WHERE `code` = " . esc($code));

		return $query->row;
	}	
}