<?php
class ControllerCommonCurrency {
	public static function index() {
		load::language('common/currency');

		$data['action'] = url::link('common/currency/currency', '', request::$server['HTTPS']);

		$data['code'] = session::$data['currency'];


		$data['currencies'] = array();

		$results = localisation_currency::getCurrencies();

		foreach ($results as $result) {
			if ($result['status']) {
				$data['currencies'][] = array(
					'title'        => $result['title'],
					'code'         => $result['code'],
					'symbol_left'  => $result['symbol_left'],
					'symbol_right' => $result['symbol_right']
				);
			}
		}

		if (!isset(request::$get['route'])) {
			$data['redirect'] = url::link('common/home');
		} else {
			$url_data = request::$get;

			unset($url_data['_route_']);

			$route = $url_data['route'];

			unset($url_data['route']);

			$url = '';

			if ($url_data) {
				$url = '&' . urldecode(http_build_query($url_data, '', '&'));
			}

			$data['redirect'] = url::link($route, $url, request::$server['HTTPS']);
		}

		return load::view('common/currency', $data);
	}

	public static function currency() {
		if (isset(request::$post['code'])) {
			session::$data['currency'] = request::$post['code'];
		
			unset(session::$data['shipping_method']);
			unset(session::$data['shipping_methods']);
		}
		
		if (isset(request::$post['redirect'])) {
			response::redirect(request::$post['redirect']);
		} else {
			response::redirect(url::link('common/home'));
		}
	}
}