<?php
class ControllerCommonMaintenance {
	public static function index() {
		load::language('common/maintenance');

		document::setTitle(language::get('heading_title'));

		if (request::$server['SERVER_PROTOCOL'] == 'HTTP/1.1') {
			response::addHeader('HTTP/1.1 503 Service Unavailable');
		} else {
			response::addHeader('HTTP/1.0 503 Service Unavailable');
		}

		response::addHeader('Retry-After: 3600');

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_maintenance'),
			'href' => url::link('common/maintenance')
		);

		$data['message'] = language::get('text_message');

		$data['header'] = load::controller('common/header');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('common/maintenance', $data));
	}
}
