<?php
class ControllerExtensionModuleInformation {
	public static function index() {
		load::language('extension/module/information');


		$data['informations'] = array();

		foreach (catalog_information::getInformations() as $result) {
			$data['informations'][] = array(
				'title' => $result['title'],
				'href'  => url::link('information/information', 'information_id=' . $result['information_id'])
			);
		}

		$data['contact'] = url::link('information/contact');
		$data['sitemap'] = url::link('information/sitemap');

		return load::view('extension/module/information', $data);
	}
}