<?php
class ControllerExtensionPaymentBankTransfer {
	public static function index() {
		load::language('extension/payment/bank_transfer');

		$data['bank'] = nl2br(config::get('payment_bank_transfer_bank' . config('language_id')));

		return load::view('extension/payment/bank_transfer', $data);
	}

	public static function confirm() {
		$json = array();
		
		if (isset(session::$data['payment_method']['code']) && session::$data['payment_method']['code'] == 'bank_transfer') {
			load::language('extension/payment/bank_transfer');


			$comment  = language::get('text_instruction') . "\n\n";
			$comment .= config::get('payment_bank_transfer_bank' . config('language_id')) . "\n\n";
			$comment .= language::get('text_payment');

			checkout_order::addOrderHistory(session::$data['order_id'], config::get('payment_bank_transfer_order_status_id'), $comment, true);
		
			$json['redirect'] = url::link('checkout/success');
		}
		
		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));		
	}
}