<?php
class ControllerExtensionPaymentCheque {
	public static function index() {
		load::language('extension/payment/cheque');

		$data['payable'] = config::get('payment_cheque_payable');
		$data['address'] = nl2br(config('address'));

		return load::view('extension/payment/cheque', $data);
	}

	public static function confirm() {
		$json = array();
		
		if (isset(session::$data['payment_method']['code']) && session::$data['payment_method']['code'] == 'cheque') {
			load::language('extension/payment/cheque');


			$comment  = language::get('text_payable') . "\n";
			$comment .= config::get('payment_cheque_payable') . "\n\n";
			$comment .= language::get('text_address') . "\n";
			$comment .= config('address') . "\n\n";
			$comment .= language::get('text_payment') . "\n";
			
			checkout_order::addOrderHistory(session::$data['order_id'], config::get('payment_cheque_order_status_id'), $comment, true);
			
			$json['redirect'] = url::link('checkout/success');
		}
		
		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}
}