<?php
class ControllerStartupRouter {
	public static function index() {
		// Route
		if (isset(request::$get['route']) && request::$get['route'] != 'startup/router') {
			$route = request::$get['route'];
		} else {
			$route = config::get('action_default');
		}
		
		// Sanitize the call
		$route = preg_replace('/[^a-zA-Z0-9_\/]/', '', (string)$route);
		
		// We dont want to use the loader class as it would make an controller callable.
		$action = $route;
		
		// Any output needs to be another Action object.
		$output = action::execute($route);
		
		return $output;
	}
}
