<?php
class ControllerStartupSass {
	public static function index() {
		$files = glob('view/theme/' . config('theme') . '/stylesheet/*.scss');

		if ($files) {
			foreach ($files as $file) {
				// Get the filename
				$filename = basename($file, '.scss');

				$stylesheet = 'view/theme/' . config('theme') . '/stylesheet/' . $filename . '.css';

				if (!is_file($stylesheet) || !config::get('developer_sass')) {
					$scss = new \ScssPhp\ScssPhp\Compiler();
					$scss::setImportPaths('view/theme/' . config('theme') . '/stylesheet/');

					$output = $scss::compileString('@import "' . $filename . '.scss"')::getCss();
					$handle = fopen($stylesheet, 'w');

					flock($handle, LOCK_EX);

					fwrite($handle, $output);

					fflush($handle);

					flock($handle, LOCK_UN);

					fclose($handle);
				}
			}
		}
	}
}
