<?php
class ControllerStartupSession {
	public static function index() {
		if (isset(request::$get['api_token']) && isset(request::$get['route']) && substr(request::$get['route'], 0, 4) == 'api/') {
			db::query("DELETE FROM `api_session` WHERE TIMESTAMPADD(HOUR, 1, date_modified) < NOW()");
					
			// Make sure the IP is allowed
			$api_query = db::query("SELECT DISTINCT * FROM `api` `a` LEFT JOIN `api_session` `as` ON (a.api_id = as.api_id) LEFT JOIN api_ip `ai` ON (a.api_id = ai.api_id) WHERE a.status = '1' AND `as`.`session_id` = " . esc(request::$get['api_token']) . " AND ai.ip = " . esc(request::$server['REMOTE_ADDR']));
		 
			if ($api_query->num_rows) {
				session::start(request::$get['api_token']);
				
				// keep the session alive
				db::query("UPDATE `api_session` SET `date_modified` = NOW() WHERE `api_session_id` = " . (int)$api_query->row['api_session_id']);
			}
		} else {
			if (isset($_COOKIE[config::get('session_name')])) {
				$session_id = $_COOKIE[config::get('session_name')];
			} else {
				$session_id = '';
			}
			
			session::start($session_id);
			
			setcookie(config::get('session_name'), session::getId(), ini_get('session.cookie_lifetime'), ini_get('session.cookie_path'), ini_get('session.cookie_domain'));	
		}
	}
}