<?php
class account_return {
	public static function addReturn($data) {
		db::query("INSERT INTO `return` SET order_id = " . (int)$data['order_id'] . ", product_id = " . (int)$data['product_id'] . ", customer_id = " . (int)customer::getId() . ", firstname = " . esc($data['firstname']) . ", lastname = " . esc($data['lastname']) . ", email = " . esc($data['email']) . ", telephone = " . esc($data['telephone']) . ", product = " . esc($data['product']) . ", model = " . esc($data['model']) . ", quantity = " . (int)$data['quantity'] . ", opened = " . (int)$data['opened'] . ", return_reason_id = " . (int)$data['return_reason_id'] . ", return_status_id = " . config('return_status_id') . ", comment = " . esc($data['comment']) . ", date_ordered = " . esc($data['date_ordered']) . ", date_added = NOW(), date_modified = NOW()");

		return db::getLastId();
	}

	public static function getReturn($return_id) {
		$query = db::query("SELECT r.return_id, r.order_id, r.firstname, r.lastname, r.email, r.telephone, r.product, r.model, r.quantity, r.opened, (SELECT rr.name FROM return_reason rr WHERE rr.return_reason_id = r.return_reason_id AND rr.language_id = " . config('language_id') . ") AS reason, (SELECT ra.name FROM return_action ra WHERE ra.return_action_id = r.return_action_id AND ra.language_id = " . config('language_id') . ") AS action, (SELECT rs.name FROM return_status rs WHERE rs.return_status_id = r.return_status_id AND rs.language_id = " . config('language_id') . ") AS status, r.comment, r.date_ordered, r.date_added, r.date_modified FROM `return` r WHERE r.return_id = " . (int)$return_id . " AND r.customer_id = '" . customer::getId() . "'");

		return $query->row;
	}

	public static function getReturns($start = 0, $limit = 20) {
		if ($start < 0) {
			$start = 0;
		}

		if ($limit < 1) {
			$limit = 20;
		}

		$query = db::query("SELECT r.return_id, r.order_id, r.firstname, r.lastname, rs.name as status, r.date_added FROM `return` r LEFT JOIN return_status rs ON (r.return_status_id = rs.return_status_id) WHERE r.customer_id = " . (int)customer::getId() . " AND rs.language_id = " . config('language_id') . " ORDER BY r.return_id DESC LIMIT " . (int)$start . "," . (int)$limit);

		return $query->rows;
	}

	public static function getTotalReturns() {
		$query = db::query("SELECT COUNT(*) AS total FROM `return`WHERE customer_id = '" . customer::getId() . "'");

		return $query->row['total'];
	}

	public static function getReturnHistories($return_id) {
		$query = db::query("SELECT rh.date_added, rs.name AS status, rh.comment FROM return_history rh LEFT JOIN return_status rs ON rh.return_status_id = rs.return_status_id WHERE rh.return_id = " . (int)$return_id . " AND rs.language_id = " . config('language_id') . " ORDER BY rh.date_added ASC");

		return $query->rows;
	}
}
