<?php
class account_transaction {
	public static function getTransactions($data = array()) {
		$sql = "SELECT * FROM `customer_transaction` WHERE customer_id = " . (int)customer::getId();

		$sort_data = array(
			'amount',
			'description',
			'date_added'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY date_added";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getTotalTransactions() {
		$query = db::query("SELECT COUNT(*) AS total FROM `customer_transaction` WHERE customer_id = " . (int)customer::getId());

		return $query->row['total'];
	}

	public static function getTotalAmount() {
		$query = db::query("SELECT SUM(amount) AS total FROM `customer_transaction` WHERE customer_id = " . (int)customer::getId() . " GROUP BY customer_id");

		if ($query->num_rows) {
			return $query->row['total'];
		} else {
			return 0;
		}
	}
}