<?php

class extension_credit_card_squareup {
    public static function addCustomer($data) {
        db::query("INSERT INTO `squareup_customer` SET customer_id=" . (int)$data['customer_id'] . ", sandbox=" . (int)$data['sandbox'] . ", square_customer_id=" . esc($data['square_customer_id']));
    }

    public static function getCustomer($customer_id, $sandbox) {
        return db::query("SELECT * FROM `squareup_customer` WHERE customer_id = " . (int)$customer_id . " AND sandbox=" . (int)$sandbox)->row;
    }

    public static function addCard($customer_id, $sandbox, $data) {
        db::query("INSERT INTO `squareup_token` SET customer_id=" . (int)$customer_id . ", sandbox=" . (int)$sandbox . ", token=" . esc($data['id']) . ", brand='" . db::escape($data['card_brand']) . "', ends_in=" . (int)$data['last_4'] . ", date_added=NOW()");
    }

    public static function getCard($squareup_token_id) {
        return db::query("SELECT * FROM `squareup_token` WHERE squareup_token_id=" . (int)$squareup_token_id)->row;
    }
    
    public static function getCards($customer_id, $sandbox) {
        return db::query("SELECT * FROM `squareup_token` WHERE customer_id=" . (int)$customer_id . " AND sandbox=" . (int)$sandbox)->rows;
    }

    public static function cardExists($customer_id, $data) {
        return db::query("SELECT * FROM `squareup_token` WHERE customer_id=" . (int)$customer_id . " AND brand=" . esc($data['card_brand']) . " AND ends_in=" . (int)$data['last_4'])->num_rows > 0;
    }

    public static function verifyCardCustomer($squareup_token_id, $customer_id) {
        return db::query("SELECT * FROM `squareup_token` WHERE squareup_token_id=" . (int)$squareup_token_id . " AND customer_id=" . (int)$customer_id)->num_rows > 0;
    }

    public static function deleteCard($squareup_token_id) {
        db::query("DELETE FROM `squareup_token` WHERE squareup_token_id=" . (int)$squareup_token_id);
    }
}