<?php
class extension_payment_paypoint {
	public static function getMethod($address, $total) {
		load::language('extension/payment/paypoint');

		$query = db::query("SELECT * FROM zone_to_geo_zone WHERE geo_zone_id = " . (int)config::get('paypoint_geo_zone_id') . " AND country_id = " . (int)$address['country_id'] . " AND (zone_id = " . (int)$address['zone_id'] . " OR zone_id = '0')");

		if (config::get('payment_paypoint_total') > 0 && config::get('payment_paypoint_total') > $total) {
			$status = false;
		} elseif (!config::get('paypoint_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
			$status = false;
		}

		$method_data = array();

		if ($status) {
			$method_data = array(
				'code'       => 'paypoint',
				'title'      => language::get('text_title'),
				'terms'      => '',
				'sort_order' => config::get('paypoint_sort_order')
			);
		}

		return $method_data;
	}
}