<?php
class extension_payment_pp_pro_iframe {
	public static function getMethod($address, $total) {
		load::language('extension/payment/pp_pro_iframe');

		$query = db::query("SELECT * FROM zone_to_geo_zone WHERE geo_zone_id = " . (int)config::get('payment_pp_pro_iframe_geo_zone_id') . " AND country_id = " . (int)$address['country_id'] . " AND (zone_id = " . (int)$address['zone_id'] . " OR zone_id = '0')");

		if (config::get('payment_pp_pro_iframe_total') > $total) {
			$status = false;
		} elseif (!config::get('payment_pp_pro_iframe_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
		$status = false;
		}

		$method_data = array();

		if ($status) {
			$method_data = array(
				'code'       => 'pp_pro_iframe',
				'title'      => language::get('text_title'),
				'terms'      => '',
				'sort_order' => config::get('payment_pp_pro_iframe_sort_order')
			);
		}

		return $method_data;
	}

	public static function addOrder($order_data) {
		db::query("INSERT INTO `paypal_iframe_order` SET `order_id` = " . (int)$order_data['order_id'] . ", `date_added` = NOW(), `date_modified` = NOW(), `capture_status` = " . esc($order_data['capture_status']) . ", `currency_code` = " . esc($order_data['currency_code']) . ", `total` = '" . (float)$order_data['total'] . "', `authorization_id` = " . esc($order_data['authorization_id']));

		return db::getLastId();
	}

	public static function addTransaction($transaction_data) {
		db::query("INSERT INTO `paypal_iframe_order_transaction` SET `paypal_iframe_order_id` = " . (int)$transaction_data['paypal_iframe_order_id'] . ", `transaction_id` = " . esc($transaction_data['transaction_id']) . ", `parent_id` = " . esc($transaction_data['parent_id']) . ", `date_added` = NOW(), `note` = " . esc($transaction_data['note']) . ", `msgsubid` = " . esc($transaction_data['msgsubid']) . ", `receipt_id` = " . esc($transaction_data['receipt_id']) . ", `payment_type` = " . esc($transaction_data['payment_type']) . ", `payment_status` = " . esc($transaction_data['payment_status']) . ", `pending_reason` = " . esc($transaction_data['pending_reason']) . ", `transaction_entity` = " . esc($transaction_data['transaction_entity']) . ", `amount` = '" . (float)$transaction_data['amount'] . "', `debug_data` = " . esc($transaction_data['debug_data']));
	}
}