<?php
class extension_shipping_pilibaba {
	static function getQuote($address) {
		load::language('extension/shipping/pilibaba');

		$status = true;

		$method_data = array();

		if ($status) {
			$quote_data = array();

			$quote_data['pilibaba'] = array(
				'code'         => 'pilibaba.pilibaba',
				'title'        => language::get('text_description'),
				'cost'         => config::get('payment_pilibaba_shipping_fee'),
				'tax_class_id' => 0,
				'text'         => currency::format(tax::calculate(config::get('payment_pilibaba_shipping_fee'), 0, config('tax')), session::$data['currency'])
			);

			$method_data = array(
				'code'       => 'pilibaba',
				'title'      => language::get('text_title'),
				'quote'      => $quote_data,
				'sort_order' => 1,
				'error'      => false
			);
		}

		return $method_data;
	}
}