<?php
class extension_total_low_order_fee {
	public static function getTotal($total) {
		if (cart::getSubTotal() && (cart::getSubTotal() < config::get('total_low_order_fee_total'))) {
			load::language('extension/total/low_order_fee');

			$total['totals'][] = array(
				'code'       => 'low_order_fee',
				'title'      => language::get('text_low_order_fee'),
				'value'      => config::get('total_low_order_fee_fee'),
				'sort_order' => config::get('total_low_order_fee_sort_order')
			);

			if (config::get('total_low_order_fee_tax_class_id')) {
				$tax_rates = tax::getRates(config::get('total_low_order_fee_fee'), config::get('total_low_order_fee_tax_class_id'));

				foreach ($tax_rates as $tax_rate) {
					if (!isset($total['taxes'][$tax_rate['tax_rate_id']])) {
						$total['taxes'][$tax_rate['tax_rate_id']] = $tax_rate['amount'];
					} else {
						$total['taxes'][$tax_rate['tax_rate_id']] += $tax_rate['amount'];
					}
				}
			}

			$total['total'] += config::get('total_low_order_fee_fee');
		}
	}
}