<?php
class extension_total_sub_total {
	public static function getTotal($total) {
		load::language('extension/total/sub_total');

		$sub_total = cart::getSubTotal();

		if (!empty(session::$data['vouchers'])) {
			foreach (session::$data['vouchers'] as $voucher) {
				$sub_total += $voucher['amount'];
			}
		}

		$total['totals'][] = array(
			'code'       => 'sub_total',
			'title'      => language::get('text_sub_total'),
			'value'      => $sub_total,
			'sort_order' => config::get('total_sub_total_sort_order')
		);

		$total['total'] += $sub_total;
	}
}
