<?php
class localisation_currency {
	public static function getCurrencyByCode($currency) {
		$query = db::query("SELECT DISTINCT * FROM `currency` WHERE `code` = " . esc($currency));

		return $query->row;
	}

	public static function getCurrencies() {
		$currency_data = cache::get('currency');

		if (!$currency_data) {
			$currency_data = array();

			$query = db::query("SELECT * FROM `currency` WHERE `status` = '1' ORDER BY `title` ASC");

			foreach ($query->rows as $result) {
				$currency_data[$result['code']] = array(
					'currency_id'   => $result['currency_id'],
					'title'         => $result['title'],
					'code'          => $result['code'],
					'symbol_left'   => $result['symbol_left'],
					'symbol_right'  => $result['symbol_right'],
					'decimal_place' => $result['decimal_place'],
					'value'         => $result['value'],
					'status'        => $result['status'],
					'date_modified' => $result['date_modified']
				);
			}

			cache::set('currency', $currency_data);
		}

		return $currency_data;
	}
}
