<?php
class localisation_language {
	public static function getLanguage($language_id) {
		$query = db::query("SELECT * FROM language WHERE language_id = " . (int)$language_id);

		return $query->row;
	}

	public static function getLanguages() {
		$language_data = cache::get('catalog.language');

		if (!$language_data) {
			$language_data = array();

			$query = db::query("SELECT * FROM language WHERE status = '1' ORDER BY sort_order, name");

			foreach ($query->rows as $result) {
				$language_data[$result['code']] = array(
					'language_id' => $result['language_id'],
					'name'        => $result['name'],
					'code'        => $result['code'],
					'locale'      => $result['locale'],
					'image'       => $result['image'],
					'directory'   => $result['directory'],
					'sort_order'  => $result['sort_order'],
					'status'      => $result['status']
				);
			}

			cache::set('catalog.language', $language_data);
		}

		return $language_data;
	}
}