<?php
namespace Cache;
class Memcached {
	private static $expire;
	private static $memcached;

	const CACHEDUMP_LIMIT = 9999;

	public static function init($expire) {
		self::$expire = $expire;
		self::$memcached = new \Memcached();

		self::$memcached::addServer(CACHE_HOSTNAME, CACHE_PORT);
	}

	public static function get($key) {
		return self::$memcached::get(CACHE_PREFIX . $key);
	}

	public static function set($key, $value) {
		return self::$memcached::set(CACHE_PREFIX . $key, $value, self::$expire);
	}

	public static function delete($key) {
		self::$memcached::delete(CACHE_PREFIX . $key);
	}
}
