<?php
class ControllerCommonDeveloper {
	public static function index() {
		load::language('common/developer');


		$data['developer_theme'] = config::get('developer_theme');
		$data['developer_sass'] = config::get('developer_sass');

		$eval = false;

		$eval = '$eval = true;';

		eval($eval);

		if ($eval === true) {
			$data['eval'] = true;
		} else {

			admin_setting_setting::editSetting('developer', array('developer_theme' => 1), 0);

			$data['eval'] = false;
		}

		response::setOutput(load::view('common/developer', $data));
	}

	public static function edit() {
		load::language('common/developer');

		$json = array();

		if (!user::hasPermission('modify', 'common/developer')) {
			$json['error'] = language::get('error_permission');
		} else {

			admin_setting_setting::editSetting('developer', request::$post, 0);

			$json['success'] = language::get('text_success');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function theme() {
		load::language('common/developer');

		$json = array();

		if (!user::hasPermission('modify', 'common/developer')) {
			$json['error'] = language::get('error_permission');
		} else {
			$directories = glob(DIR_CACHE . '/template/*', GLOB_ONLYDIR);

			if ($directories) {
				foreach ($directories as $directory) {
					$files = glob($directory . '/*');

					foreach ($files as $file) { 
						if (is_file($file)) {
							unlink($file);
						}
					}

					if (is_dir($directory)) {
						rmdir($directory);
					}
				}
			}

			$json['success'] = sprintf(language::get('text_cache'), language::get('text_theme'));
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function sass() {
		load::language('common/developer');

		$json = array();

		if (!user::hasPermission('modify', 'common/developer')) {
			$json['error'] = language::get('error_permission');
		} else {
			// Before we delete we need to make sure there is a sass file to regenerate the css
			$file = DIR_APPLICATION  . 'view/stylesheet/bootstrap.css';

			if (is_file($file) && is_file(DIR_APPLICATION . 'view/stylesheet/sass/_bootstrap.scss')) {
				unlink($file);
			}
			 
			$files = glob(DIR_CATALOG  . 'view/theme/*/stylesheet/sass/_bootstrap.scss');
			 
			foreach ($files as $file) {
				$file = substr($file, 0, -21) . '/bootstrap.css';

				if (is_file($file)) {
					unlink($file);
				}
			}

			$json['success'] = sprintf(language::get('text_cache'), language::get('text_sass'));
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}
}
