<?php
class ControllerExtensionModulePilibabaButton {
	public static function index() {
		load::language('extension/module/pilibaba_button');


		document::setTitle(language::get('heading_title'));

		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('module_pilibaba_button', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=module'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=module')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/module/pilibaba_button')
		);

		$data['action'] = url::link('extension/module/pilibaba_button');

		$data['cancel'] = url::link('marketplace/extension', '&type=module');

		if (isset(request::$post['module_pilibaba_button_status'])) {
			$data['module_pilibaba_button_status'] = request::$post['module_pilibaba_button_status'];
		} else {
			$data['module_pilibaba_button_status'] = config::get('module_pilibaba_button_status');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/module/pilibaba_button', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/module/pilibaba_button')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
}