<?php
class ControllerMarketplaceApi {
	public static function index() {	
		load::language('marketplace/api');
			
			
		response::setOutput(load::view('marketplace/api', $data));
	}
	
	public static function save() {
		load::language('marketplace/api');

		$json = array();
		
		if (!user::hasPermission('modify', 'marketplace/api')) {
			$json['error']['warning'] = language::get('error_permission');
		}

		if (!request::$post['opencart_username']) {
			$json['error']['username'] = language::get('error_username');
		}

		if (!request::$post['opencart_secret']) {
			$json['error']['secret'] = language::get('error_secret');
		}		

		if (!$json) {
			
			admin_setting_setting::editSetting('opencart', request::$post);
			
			$json['success'] = language::get('text_success');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}
}