<?php
class admin_design_banner {
	public static function addBanner($data) {
		db::query("INSERT INTO banner SET name = " . esc($data['name']) . ", status = " . (int)$data['status']);

		$banner_id = db::getLastId();

		if (isset($data['banner_image'])) {
			foreach ($data['banner_image'] as $language_id => $value) {
				foreach ($value as $banner_image) {
					db::query("INSERT INTO banner_image SET banner_id = " . (int)$banner_id . ", language_id = " . (int)$language_id . ", title = '" .  db::escape($banner_image['title']) . "', link = '" .  db::escape($banner_image['link']) . "', image = '" .  db::escape($banner_image['image']) . "', sort_order = '" .  (int)$banner_image['sort_order'] . "'");
				}
			}
		}

		return $banner_id;
	}

	public static function editBanner($banner_id, $data) {
		db::query("UPDATE banner SET name = " . esc($data['name']) . ", status = " . (int)$data['status'] . " WHERE banner_id = " . (int)$banner_id);

		db::query("DELETE FROM banner_image WHERE banner_id = " . (int)$banner_id);

		if (isset($data['banner_image'])) {
			foreach ($data['banner_image'] as $language_id => $value) {
				foreach ($value as $banner_image) {
					db::query("INSERT INTO banner_image SET banner_id = " . (int)$banner_id . ", language_id = " . (int)$language_id . ", title = '" .  db::escape($banner_image['title']) . "', link = '" .  db::escape($banner_image['link']) . "', image = '" .  db::escape($banner_image['image']) . "', sort_order = " . (int)$banner_image['sort_order']);
				}
			}
		}
	}

	public static function deleteBanner($banner_id) {
		db::query("DELETE FROM banner WHERE banner_id = " . (int)$banner_id);
		db::query("DELETE FROM banner_image WHERE banner_id = " . (int)$banner_id);
	}

	public static function getBanner($banner_id) {
		$query = db::query("SELECT DISTINCT * FROM banner WHERE banner_id = " . (int)$banner_id);

		return $query->row;
	}

	public static function getBanners($data = array()) {
		$sql = "SELECT * FROM banner";

		$sort_data = array(
			'name',
			'status'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY name";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getBannerImages($banner_id) {
		$banner_image_data = array();

		$banner_image_query = db::query("SELECT * FROM banner_image WHERE banner_id = " . (int)$banner_id . " ORDER BY sort_order ASC");

		foreach ($banner_image_query->rows as $banner_image) {
			$banner_image_data[$banner_image['language_id']][] = array(
				'title'      => $banner_image['title'],
				'link'       => $banner_image['link'],
				'image'      => $banner_image['image'],
				'sort_order' => $banner_image['sort_order']
			);
		}

		return $banner_image_data;
	}

	public static function getTotalBanners() {
		$query = db::query("SELECT COUNT(*) AS total FROM banner");

		return $query->row['total'];
	}
}
