<?php
class admin_design_theme {
	public static function editTheme($store_id, $theme, $route, $code) {
		db::query("DELETE FROM `theme` WHERE store_id = " . (int)$store_id . " AND theme = " . esc($theme) . " AND route = " . esc($route));
		
		db::query("INSERT INTO `theme` SET store_id = " . (int)$store_id . ", theme = " . esc($theme) . ", route = " . esc($route) . ", code = " . esc($code) . ", date_added = NOW()");
	}

	public static function deleteTheme($theme_id) {
		db::query("DELETE FROM `theme` WHERE theme_id = " . (int)$theme_id);
	}

	public static function getTheme($store_id, $theme, $route) {
		$query = db::query("SELECT * FROM `theme` WHERE store_id = " . (int)$store_id . " AND theme = " . esc($theme) . " AND route = " . esc($route));

		return $query->row;
	}
	
	public static function getThemes($start = 0, $limit = 10) {
		if ($start < 0) {
			$start = 0;
		}

		if ($limit < 1) {
			$limit = 10;
		}		
		
		$query = db::query("SELECT *, (SELECT name FROM `store` s WHERE s.store_id = t.store_id) AS store FROM `theme` t ORDER BY t.date_added DESC LIMIT " . (int)$start . "," . (int)$limit);

		return $query->rows;
	}	
	
	public static function getTotalThemes() {
		$query = db::query("SELECT COUNT(*) AS total FROM `theme`");

		return $query->row['total'];
	}	
}