<?php
class admin_design_translation {
	public static function addTranslation($data) {
		db::query("INSERT INTO `translation` SET `store_id` = " . (int)$data['store_id'] . ", `language_id` = " . (int)$data['language_id'] . ", `route` = " . esc($data['route']) . ", `key` = " . esc($data['key']) . ", `value` = " . esc($data['value']) . ", `date_added` = NOW()");
	}
		
	public static function editTranslation($translation_id, $data) {
		db::query("UPDATE `translation` SET `store_id` = " . (int)$data['store_id'] . ", `language_id` = " . (int)$data['language_id'] . ", `route` = " . esc($data['route']) . ", `key` = " . esc($data['key']) . ", `value` = " . esc($data['value']) . " WHERE `translation_id` = " . (int)$translation_id);
	}

	public static function deleteTranslation($translation_id) {
		db::query("DELETE FROM `translation` WHERE `translation_id` = " . (int)$translation_id);
	}

	public static function getTranslation($translation_id) {
		$query = db::query("SELECT DISTINCT * FROM `translation` WHERE `translation_id` = " . (int)$translation_id);

		return $query->row;
	}
	
	public static function getTranslations($data = array()) {
		$sql = "SELECT *, (SELECT s.name FROM `store` s WHERE s.store_id = t.store_id) AS store, (SELECT l.name FROM `language` l WHERE l.language_id = t.language_id) AS language FROM `translation` t";
		
		$sort_data = array(
			'store',
			'language',
			'route',
			'key',
			'value'
		);
		
		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY `" . $data['sort'] . "`";
		} else {
			$sql .= " ORDER BY store";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}	
				
		$query = db::query($sql);

		return $query->rows;
	}	

	public static function getTotalTranslations() {
		$query = db::query("SELECT COUNT(*) AS total FROM `translation`");
		
		return $query->row['total'];
	}	
}
