<?php
class admin_extension_fraud_ip {
	public static function install() {
		db::query("
		CREATE TABLE IF NOT EXISTS `fraud_ip` (
		  `ip` varchar(40) NOT NULL,
		  `date_added` datetime NOT NULL,
		  PRIMARY KEY (`ip`)
		) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;
		");
	}

	public static function uninstall() {
		db::query("DROP TABLE IF EXISTS `fraud_ip`");
	}

    public static function addIp($ip) {
        db::query("INSERT INTO `fraud_ip` SET `ip` = " . esc($ip) . ", date_added = NOW()");
    }

    public static function removeIp($ip) {
        db::query("DELETE FROM `fraud_ip` WHERE `ip` = " . esc($ip));
    }

	public static function getIps($start = 0, $limit = 10) {
        if ($start < 0) {
			$start = 0;
		}

		if ($limit < 1) {
			$limit = 10;
		}

        $query = db::query("SELECT * FROM `fraud_ip` ORDER BY `ip` ASC LIMIT " . (int)$start . "," . (int)$limit);

		return $query->rows;
	}

	public static function getTotalIps() {
		$query = db::query("SELECT COUNT(*) AS total FROM `fraud_ip`");

		return $query->row['total'];
	}

	public static function getTotalIpsByIp($ip) {
		$query = db::query("SELECT COUNT(*) AS total FROM `fraud_ip` WHERE ip = " . esc($ip));

		return $query->row['total'];
	}
}
