<?php
class admin_setting_module {
	public static function addModule($code, $data) {
		db::query("INSERT INTO `module` SET `name` = " . esc($data['name']) . ", `code` = " . esc($code) . ", `setting` = " . esc(json_encode($data)));
	}
	
	public static function editModule($module_id, $data) {
		db::query("UPDATE `module` SET `name` = " . esc($data['name']) . ", `setting` = " . esc(json_encode($data)) . " WHERE `module_id` = " . (int)$module_id);
	}

	public static function deleteModule($module_id) {
		db::query("DELETE FROM `module` WHERE `module_id` = " . (int)$module_id);
		db::query("DELETE FROM `layout_module` WHERE `code` LIKE '%." . (int)$module_id . "'");
	}
		
	public static function getModule($module_id) {
		$query = db::query("SELECT * FROM `module` WHERE `module_id` = " . (int)$module_id);

		if ($query->row) {
			return json_decode($query->row['setting'], true);
		} else {
			return array();
		}
	}
	
	public static function getModules() {
		$query = db::query("SELECT * FROM `module` ORDER BY `code`");

		return $query->rows;
	}	
		
	public static function getModulesByCode($code) {
		$query = db::query("SELECT * FROM `module` WHERE `code` = " . esc($code) . " ORDER BY `name`");

		return $query->rows;
	}	
	
	public static function deleteModulesByCode($code) {
		db::query("DELETE FROM `module` WHERE `code` = " . esc($code));
		db::query("DELETE FROM `layout_module` WHERE `code` LIKE " . esc($code) . " OR `code` LIKE " . esc($code . '.%'));
	}	
}