<?php
class admin_setting_setting {
	public static function getSetting($code, $store_id = 0) {
		$setting_data = array();

		$query = db::query("SELECT * FROM setting WHERE store_id = " . (int)$store_id . " AND `code` = " . esc($code));

		foreach ($query->rows as $result) {
			if (!$result['serialized']) {
				$setting_data[$result['key']] = $result['value'];
			} else {
				$setting_data[$result['key']] = json_decode($result['value'], true);
			}
		}

		return $setting_data;
	}

	public static function editSetting($code, $data, $store_id = 0) {
		db::query("DELETE FROM `setting` WHERE store_id = " . (int)$store_id . " AND `code` = " . esc($code));

		foreach ($data as $key => $value) {
			if (substr($key, 0, strlen($code)) == $code) {
				if (!is_array($value)) {
					db::query("INSERT INTO setting SET store_id = " . (int)$store_id . ", `code` = " . esc($code) . ", `key` = " . esc($key) . ", `value` = " . esc($value));
				} else {
					db::query("INSERT INTO setting SET store_id = " . (int)$store_id . ", `code` = " . esc($code) . ", `key` = " . esc($key) . ", `value` = " . esc(json_encode($value, true)) . ", serialized = '1'");
				}
			}
		}
	}

	public static function deleteSetting($code, $store_id = 0) {
		db::query("DELETE FROM setting WHERE store_id = " . (int)$store_id . " AND `code` = " . esc($code));
	}
	
	public static function getSettingValue($key, $store_id = 0) {
		$query = db::query("SELECT value FROM setting WHERE store_id = " . (int)$store_id . " AND `key` = " . esc($key));

		if ($query->num_rows) {
			return $query->row['value'];
		} else {
			return null;	
		}
	}
	
	public static function editSettingValue($code = '', $key = '', $value = '', $store_id = 0) {
		if (!is_array($value)) {
			db::query("UPDATE setting SET `value` = " . esc($value) . ", serialized = '0'  WHERE `code` = " . esc($code) . " AND `key` = " . esc($key) . " AND store_id = " . (int)$store_id);
		} else {
			db::query("UPDATE setting SET `value` = " . esc(json_encode($value)) . ", serialized = '1' WHERE `code` = " . esc($code) . " AND `key` = " . esc($key) . " AND store_id = " . (int)$store_id);
		}
	}
}
