<?php
class admin_tool_backup {
	public static function getTables() {
		$table_data = array();

		$query = db::query("SHOW TABLES FROM `" . DB_DATABASE . "`");

		foreach ($query->rows as $result) {
			$table = reset($result);
			if ($table) {
				$table_data[] = $table;
			}
		}

		return $table_data;
	}

	public static function backup($tables) {
		$output = '';

		foreach ($tables as $table) {
			$output .= 'TRUNCATE TABLE `' . $table . '`;' . "\n\n";

			$query = db::query("SELECT * FROM `" . $table . "`");

			foreach ($query->rows as $result) {
				$fields = '';

				foreach (array_keys($result) as $value) {
					$fields .= '`' . $value . '`, ';
				}

				$values = '';

				foreach (array_values($result) as $value) {
					if ($value !== null) {
						$value = str_replace(array("\x00", "\x0a", "\x0d", "\x1a"), array('\0', '\n', '\r', '\Z'), $value);
						$value = str_replace(array("\n", "\r", "\t"), array('\n', '\r', '\t'), $value);
						$value = str_replace('\\', '\\\\',	$value);
						$value = str_replace('\'', '\\\'',	$value);
						$value = str_replace('\\\n', '\n',	$value);
						$value = str_replace('\\\r', '\r',	$value);
						$value = str_replace('\\\t', '\t',	$value);
						$values .= '\'' . $value . '\', ';
					} else {
						$values .= 'NULL, ';
					}
				}

				$output .= 'INSERT INTO `' . $table . '` (' . preg_replace('/, $/', '', $fields) . ') VALUES (' . preg_replace('/, $/', '', $values) . ');' . "\n";
			}

			$output .= "\n\n";
		}

		return $output;
	}
}