<?php
class ControllerApiCoupon {
	public static function index() {
		load::language('api/coupon');

		// Delete past coupon in case there is an error
		unset(session::$data['coupon']);

		$json = array();

		if (!isset(session::$data['api_id'])) {
			$json['error'] = language::get('error_permission');
		} else {

			if (isset(request::$post['coupon'])) {
				$coupon = request::$post['coupon'];
			} else {
				$coupon = '';
			}

			$coupon_info = extension_total_coupon::getCoupon($coupon);

			if ($coupon_info) {
				session::$data['coupon'] = request::$post['coupon'];

				$json['success'] = language::get('text_success');
			} else {
				$json['error'] = language::get('error_coupon');
			}
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}
}
