<?php
class ControllerApiCurrency {
	public static function index() {
		load::language('api/currency');

		$json = array();

		if (!isset(session::$data['api_id'])) {
			$json['error'] = language::get('error_permission');
		} else {

			$currency_info = localisation_currency::getCurrencyByCode(request::$post['currency']);

			if ($currency_info) {
				session::$data['currency'] = request::$post['currency'];

				unset(session::$data['shipping_method']);
				unset(session::$data['shipping_methods']);

				$json['success'] = language::get('text_success');
			} else {
				$json['error'] = language::get('error_currency');
			}
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}
}
