<?php
class ControllerCheckoutFailure {
	public static function index() {
		load::language('checkout/failure');

		document::setTitle(language::get('heading_title'));

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_basket'),
			'href' => url::link('checkout/cart')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_checkout'),
			'href' => url::link('checkout/checkout', '')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_failure'),
			'href' => url::link('checkout/failure')
		);

		$data['text_message'] = sprintf(language::get('text_message'), url::link('information/contact'));

		$data['continue'] = url::link('common/home');

		$data['column_left'] = load::controller('common/column_left');
		$data['column_right'] = load::controller('common/column_right');
		$data['content_top'] = load::controller('common/content_top');
		$data['content_bottom'] = load::controller('common/content_bottom');
		$data['footer'] = load::controller('common/footer');
		$data['header'] = load::controller('common/header');

		response::setOutput(load::view('common/success', $data));
	}
}