<?php
class ControllerCommonHome {
	public static function index() {
		document::setTitle(config('meta_title'));
		document::setDescription(config('meta_description'));
		document::setKeywords(config('meta_keyword'));

		if (isset(request::$get['route'])) {
			document::addLink(config('url'), 'canonical');
		}

		$data['column_left'] = load::controller('common/column_left');
		$data['column_right'] = load::controller('common/column_right');
		$data['content_top'] = load::controller('common/content_top');
		$data['content_bottom'] = load::controller('common/content_bottom');
		$data['footer'] = load::controller('common/footer');
		$data['header'] = load::controller('common/header');

		response::setOutput(load::view('common/home', $data));
	}
}
