<?php
class ControllerCommonLanguage {
	public static function index() {
		load::language('common/language');

		$data['action'] = url::link('common/language/language', '', request::$server['HTTPS']);

		$data['code'] = session::$data['language'];


		$data['languages'] = array();

		$results = localisation_language::getLanguages();

		foreach ($results as $result) {
			if ($result['status']) {
				$data['languages'][] = array(
					'name' => $result['name'],
					'code' => $result['code']
				);
			}
		}

		if (!isset(request::$get['route'])) {
			$data['redirect'] = url::link('common/home');
		} else {
			$url_data = request::$get;

			unset($url_data['_route_']);

			$route = $url_data['route'];

			unset($url_data['route']);

			$url = '';

			if ($url_data) {
				$url = '&' . urldecode(http_build_query($url_data, '', '&'));
			}

			$data['redirect'] = url::link($route, $url, request::$server['HTTPS']);
		}

		return load::view('common/language', $data);
	}

	public static function language() {
		if (isset(request::$post['code'])) {
			session::$data['language'] = request::$post['code'];
		}

		if (isset(request::$post['redirect'])) {
			response::redirect(request::$post['redirect']);
		} else {
			response::redirect(url::link('common/home'));
		}
	}
}