<?php
class ControllerExtensionModuleAccount {
	public static function index() {
		load::language('extension/module/account');

		$data['logged'] = customer::isLogged();
		$data['register'] = url::link('account/register', '');
		$data['login'] = url::link('account/login', '');
		$data['logout'] = url::link('account/logout', '');
		$data['forgotten'] = url::link('account/forgotten', '');
		$data['account'] = url::link('account/account', '');
		$data['edit'] = url::link('account/edit', '');
		$data['password'] = url::link('account/password', '');
		$data['address'] = url::link('account/address', '');
		$data['wishlist'] = url::link('account/wishlist');
		$data['order'] = url::link('account/order', '');
		$data['download'] = url::link('account/download', '');
		$data['reward'] = url::link('account/reward', '');
		$data['return'] = url::link('account/return', '');
		$data['transaction'] = url::link('account/transaction', '');
		$data['newsletter'] = url::link('account/newsletter', '');
		$data['recurring'] = url::link('account/recurring', '');

		return load::view('extension/module/account', $data);
	}
}