<?php
class ControllerExtensionModuleBanner {
	public static function index($setting) {
		static $module = 0;


		document::addStyle('catalog/view/javascript/jquery/swiper/css/swiper.min.css');
		document::addStyle('catalog/view/javascript/jquery/swiper/css/opencart.css');
		document::addScript('catalog/view/javascript/jquery/swiper/js/swiper.jquery.min.js');

		$data['banners'] = array();

		$results = design_banner::getBanner($setting['banner_id']);

		foreach ($results as $result) {
			if (is_file('image/' . $result['image'])) {
				$data['banners'][] = array(
					'title' => $result['title'],
					'link'  => $result['link'],
					'image' => tool_image::resize($result['image'], $setting['width'], $setting['height'])
				);
			}
		}

		$data['module'] = $module++;

		return load::view('extension/module/banner', $data);
	}
}