<?php
class ControllerExtensionModuleStore {
	public static function index() {
		$status = true;

		if (config::get('module_store_admin')) {
			self::$user = new User();

			$status = user::isLogged();
		}

		if ($status) {
			load::language('extension/module/store');

			$data['store_id'] = config('store_id');

			$data['stores'] = array();

			$data['stores'][] = array(
				'store_id' => 0,
				'name'     => language::get('text_default'),
				'url'      => HTTP_SERVER . 'index.php?route=common/home&session_id=' . session::getId()
			);


			$results = setting_store::getStores();

			foreach ($results as $result) {
				$data['stores'][] = array(
					'store_id' => $result['store_id'],
					'name'     => $result['name'],
					'url'      => $result['url'] . 'index.php?route=common/home&session_id=' . session::getId()
				);
			}

			return load::view('extension/module/store', $data);
		}
	}
}
