<?php
class ControllerExtensionPaymentCod {
	public static function index() {
		return load::view('extension/payment/cod');
	}

	public static function confirm() {
		$json = array();
		
		if (isset(session::$data['payment_method']['code']) && session::$data['payment_method']['code'] == 'cod') {

			checkout_order::addOrderHistory(session::$data['order_id'], config::get('payment_cod_order_status_id'));
		
			$json['redirect'] = url::link('checkout/success');
		}
		
		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));		
	}
}
