<?php
class ControllerStartupMaintenance {
	public static function index() {
		if (config('maintenance')) {
			// Route
			if (isset(request::$get['route']) && request::$get['route'] != 'startup/router') {
				$route = request::$get['route'];
			} else {
				$route = config::get('action_default');
			}			
			
			$ignore = array(
				'common/language/language',
				'common/currency/currency'
			);
			
			// Show site if logged in as admin
			self::$user = new User();

			if ((substr($route, 0, 17) != 'extension/payment' && substr($route, 0, 3) != 'api') && !in_array($route, $ignore) && !user::isLogged()) {
				return 'common/maintenance';
			}
		}
	}
}
