<?php
class account_recurring {
	public static function getOrderRecurring($order_recurring_id) {
		$query = db::query("SELECT `or`.*,`o`.`payment_method`,`o`.`payment_code`,`o`.`currency_code` FROM `order_recurring` `or` LEFT JOIN `order` `o` ON `or`.`order_id` = `o`.`order_id` WHERE `or`.`order_recurring_id` = " . (int)$order_recurring_id . " AND `o`.`customer_id` = " . (int)customer::getId());

		return $query->row;
	}

	public static function getOrderRecurrings($start = 0, $limit = 20) {
		if ($start < 0) {
			$start = 0;
		}

		if ($limit < 1) {
			$limit = 1;
		}

		$query = db::query("SELECT `or`.*,`o`.`payment_method`,`o`.`currency_id`,`o`.`currency_value` FROM `order_recurring` `or` LEFT JOIN `order` `o` ON `or`.`order_id` = `o`.`order_id` WHERE `o`.`customer_id` = " . (int)customer::getId() . " ORDER BY `o`.`order_id` DESC LIMIT " . (int)$start . "," . (int)$limit);

		return $query->rows;
	}
	
	public static function getOrderRecurringByReference($reference) {
		$query = db::query("SELECT * FROM `order_recurring` WHERE `reference` = " . esc($reference));

		return $query->row;
	}

	public static function getOrderRecurringTransactions($order_recurring_id) {
		$query = db::query("SELECT * FROM `order_recurring_transaction` WHERE `order_recurring_id` = " . (int)$order_recurring_id);

		return $query->rows;
	}

	public static function getTotalOrderRecurrings() {
		$query = db::query("SELECT COUNT(*) AS total FROM `order_recurring` `or` LEFT JOIN `order` `o` ON `or`.`order_id` = `o`.`order_id` WHERE `o`.`customer_id` = " . (int)customer::getId());

		return $query->row['total'];
	}
	
	public static function addOrderRecurringTransaction($order_recurring_id, $type) {
		db::query("INSERT INTO `order_recurring_transaction` SET `order_recurring_id` = " . (int)$order_recurring_id . ", `date_added` = NOW(), `type` = " . (int)$type);
	}	
	
	public static function editOrderRecurringStatus($order_recurring_id, $status) {
		db::query("UPDATE `order_recurring` SET `status` = " . (int)$status . " WHERE `order_recurring_id` = " . (int)$order_recurring_id);
	}	
}