<?php
class catalog_manufacturer {
	public static function getManufacturer($manufacturer_id) {
		$query = db::query("SELECT * FROM manufacturer m LEFT JOIN manufacturer_to_store m2s ON (m.manufacturer_id = m2s.manufacturer_id) WHERE m.manufacturer_id = " . (int)$manufacturer_id . " AND m2s.store_id = " . config('store_id'));

		return $query->row;
	}

	public static function getManufacturers($data = array()) {
		if ($data) {
			$sql = "SELECT * FROM manufacturer m LEFT JOIN manufacturer_to_store m2s ON (m.manufacturer_id = m2s.manufacturer_id) WHERE m2s.store_id = " . config('store_id');

			$sort_data = array(
				'name',
				'sort_order'
			);

			if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
				$sql .= " ORDER BY " . $data['sort'];
			} else {
				$sql .= " ORDER BY name";
			}

			if (isset($data['order']) && ($data['order'] == 'DESC')) {
				$sql .= " DESC";
			} else {
				$sql .= " ASC";
			}

			if (isset($data['start']) || isset($data['limit'])) {
				if ($data['start'] < 0) {
					$data['start'] = 0;
				}

				if ($data['limit'] < 1) {
					$data['limit'] = 20;
				}

				$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
			}

			$query = db::query($sql);

			return $query->rows;
		} else {
			$manufacturer_data = cache::get('manufacturer.' . config('store_id'));

			if (!$manufacturer_data) {
				$query = db::query("SELECT * FROM manufacturer m LEFT JOIN manufacturer_to_store m2s ON (m.manufacturer_id = m2s.manufacturer_id) WHERE m2s.store_id = " . config('store_id') . " ORDER BY name");

				$manufacturer_data = $query->rows;

				cache::set('manufacturer.' . config('store_id'), $manufacturer_data);
			}

			return $manufacturer_data;
		}
	}
}