<?php
class extension_module_paypal_smart_button {
	
	public static function hasProductInCart($product_id, $option = array(), $recurring_id = 0) {
		$query = db::query("SELECT COUNT(*) AS total FROM cart WHERE api_id = '" . (isset(session::$data['api_id']) ? (int)session::$data['api_id'] : 0) . "' AND customer_id = " . (int)customer::getId() . " AND session_id = " . esc(session::getId()) . " AND product_id = " . (int)$product_id . " AND recurring_id = " . (int)$recurring_id . " AND `option` = " . esc(json_encode($option)));
		
		return $query->row['total'];
	}
	
	public static function getCountryByCode($code) {
		$query = db::query("SELECT * FROM country WHERE iso_code_2 = " . esc($code) . " AND status = '1'");

		return $query->row;
	}
	
	public static function getZoneByCode($country_id, $code) {
		$query = db::query("SELECT * FROM zone WHERE country_id = " . (int)$country_id . " AND (code = " . esc($code) . " OR name = " . esc($code) . ") AND status = '1'");
		
		return $query->row;
	}
	
	public static function log($data, $title = null) {
		if (config::get('payment_paypal_debug')) {
			$log = new Log('paypal.log');
			$log::write('PayPal debug (' . $title . '): ' . json_encode($data));
		}
	}
}
