<?php
class extension_shipping_free {
	static function getQuote($address) {
		load::language('extension/shipping/free');

		$query = db::query("SELECT * FROM zone_to_geo_zone WHERE geo_zone_id = " . (int)config::get('shipping_free_geo_zone_id') . " AND country_id = " . (int)$address['country_id'] . " AND (zone_id = " . (int)$address['zone_id'] . " OR zone_id = '0')");

		if (!config::get('shipping_free_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
			$status = false;
		}

		if (cart::getSubTotal() < config::get('shipping_free_total')) {
			$status = false;
		}

		$method_data = array();

		if ($status) {
			$quote_data = array();

			$quote_data['free'] = array(
				'code'         => 'free.free',
				'title'        => language::get('text_description'),
				'cost'         => 0.00,
				'tax_class_id' => 0,
				'text'         => currency::format(0.00, session::$data['currency'])
			);

			$method_data = array(
				'code'       => 'free',
				'title'      => language::get('text_title'),
				'quote'      => $quote_data,
				'sort_order' => config::get('shipping_free_sort_order'),
				'error'      => false
			);
		}

		return $method_data;
	}
}