<?php
class extension_shipping_item {
	static function getQuote($address) {
		load::language('extension/shipping/item');

		$query = db::query("SELECT * FROM zone_to_geo_zone WHERE geo_zone_id = " . (int)config::get('shipping_item_geo_zone_id') . " AND country_id = " . (int)$address['country_id'] . " AND (zone_id = " . (int)$address['zone_id'] . " OR zone_id = '0')");

		if (!config::get('shipping_item_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
			$status = false;
		}

		$method_data = array();

		if ($status) {
			$items = 0;

			foreach (cart::getProducts() as $product) {
				if ($product['shipping']) {
					$items += $product['quantity'];
				}
			}

			$quote_data = array();

			$quote_data['item'] = array(
				'code'         => 'item.item',
				'title'        => language::get('text_description'),
				'cost'         => config::get('shipping_item_cost') * $items,
				'tax_class_id' => config::get('shipping_item_tax_class_id'),
				'text'         => currency::format(tax::calculate(config::get('shipping_item_cost') * $items, config::get('shipping_item_tax_class_id'), config('tax')), session::$data['currency'])
			);

			$method_data = array(
				'code'       => 'item',
				'title'      => language::get('text_title'),
				'quote'      => $quote_data,
				'sort_order' => config::get('shipping_item_sort_order'),
				'error'      => false
			);
		}

		return $method_data;
	}
}