<?php
class extension_total_credit {
	public static function getTotal($total) {
		load::language('extension/total/credit');

		$balance = customer::getBalance();

		if ((float)$balance) {
			$credit = min($balance, $total['total']);

			if ((float)$credit > 0) {
				$total['totals'][] = array(
					'code'       => 'credit',
					'title'      => language::get('text_credit'),
					'value'      => -$credit,
					'sort_order' => config::get('total_credit_sort_order')
				);

				$total['total'] -= $credit;
			}
		}
	}

	public static function confirm($order_info, $order_total) {
		load::language('extension/total/credit');

		if ($order_info['customer_id']) {
			db::query("INSERT INTO customer_transaction SET customer_id = " . (int)$order_info['customer_id'] . ", order_id = " . (int)$order_info['order_id'] . ", description = " . esc(sprintf(language::get('text_order_id'), (int)$order_info['order_id'])) . ", amount = '" . (float)$order_total['value'] . "', date_added = NOW()");
		}
	}

	public static function unconfirm($order_id) {
		db::query("DELETE FROM customer_transaction WHERE order_id = " . (int)$order_id);
	}
}
