<?php
class localisation_return_reason {
	public static function getReturnReasons($data = array()) {
		if ($data) {
			$sql = "SELECT * FROM return_reason WHERE language_id = " . config('language_id');

			$sql .= " ORDER BY name";

			if (isset($data['return']) && ($data['return'] == 'DESC')) {
				$sql .= " DESC";
			} else {
				$sql .= " ASC";
			}

			if (isset($data['start']) || isset($data['limit'])) {
				if ($data['start'] < 0) {
					$data['start'] = 0;
				}

				if ($data['limit'] < 1) {
					$data['limit'] = 20;
				}

				$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
			}

			$query = db::query($sql);

			return $query->rows;
		} else {
			$return_reason_data = cache::get('return_reason.' . config('language_id'));

			if (!$return_reason_data) {
				$query = db::query("SELECT return_reason_id, name FROM return_reason WHERE language_id = " . config('language_id') . " ORDER BY name");

				$return_reason_data = $query->rows;

				cache::set('return_reason.' . config('language_id'), $return_reason_data);
			}

			return $return_reason_data;
		}
	}
}
