<?php
class User {
	private static $user_id;
	private static $user_group_id;
	private static $username;
	private static $permission = array();

	public static function init() {

		if (isset(session::$data['user_id'])) {
			$user_query = db::query("SELECT * FROM user WHERE user_id = " . (int)session::$data['user_id'] . " AND status = '1'");

			if ($user_query->num_rows) {
				self::$user_id = $user_query->row['user_id'];
				self::$username = $user_query->row['username'];
				self::$user_group_id = $user_query->row['user_group_id'];

				db::query("UPDATE user SET ip = " . esc(request::$server['REMOTE_ADDR']) . " WHERE user_id = " . (int)session::$data['user_id']);

				$user_group_query = db::query("SELECT permission FROM user_group WHERE user_group_id = " . (int)$user_query->row['user_group_id']);

				$permissions = json_decode($user_group_query->row['permission'], true);

				if (is_array($permissions)) {
					foreach ($permissions as $key => $value) {
						self::$permission[$key] = $value;
					}
				}
			} else {
				self::logout();
			}
		}
	}

	public static function login($username, $password) {
		$user_query = db::query("SELECT * FROM user WHERE username = " . esc($username) . " AND (password = SHA1(CONCAT(salt, SHA1(CONCAT(salt, SHA1(" . esc($password) . "))))) OR password = " . esc(md5($password)) . ") AND status = '1'");

		if ($user_query->num_rows) {
			session::$data['user_id'] = $user_query->row['user_id'];

			self::$user_id = $user_query->row['user_id'];
			self::$username = $user_query->row['username'];
			self::$user_group_id = $user_query->row['user_group_id'];

			$user_group_query = db::query("SELECT permission FROM user_group WHERE user_group_id = " . (int)$user_query->row['user_group_id']);

			$permissions = json_decode($user_group_query->row['permission'], true);

			if (is_array($permissions)) {
				foreach ($permissions as $key => $value) {
					self::$permission[$key] = $value;
				}
			}

			return true;
		} else {
			return false;
		}
	}

	public static function logout() {
		unset(session::$data['user_id']);

		self::$user_id = '';
		self::$username = '';
	}

	public static function hasPermission($key, $value) {
		if (isset(self::$permission[$key])) {
			return in_array($value, self::$permission[$key]);
		} else {
			return false;
		}
	}

	public static function isLogged() {
		return self::$user_id;
	}

	public static function getId() {
		return self::$user_id;
	}

	public static function getUserName() {
		return self::$username;
	}

	public static function getGroupId() {
		return self::$user_group_id;
	}
}