<?php
namespace Template;
final class Template {
	private static $data = array();
		
	public static function set($key, $value) {
		self::$data[$key] = $value;
	}
	
	public static function render($template) {
		$file = DIR_TEMPLATE . $template . '.tpl';

		if (is_file($file)) {
			extract(self::$data);

			ob_start();

			require($file);

			return ob_get_clean();
		}

		throw new \Exception('Error: Could not load template ' . $file . '!');
		exit();
	}	
}
